<template>
  <div id="app">

    <div class="buttons">
      <button class="button is-primary">Primary</button>
      <button class="button is-link">Link</button>
    </div>


    <h3>Cadastro:</h3>
      <small id="nomeError" v-show="deuRuim">O nome é invalido</small><br>
      <input type="text" placeholder="Nome" v-model="nomeField"><br>
      <input type="email" placeholder="E-mail" v-model="emailField"><br>
      <input type="number" placeholder="Idade" v-model="idadeField"><br>
      <button @click="cadastrarUsuario">Cadastrar</button>
    <hr>
    <div v-for="(itCLiente, index) in orderClientes" :key="itCLiente.id">
      <h4>{{ index }}</h4>
      <Cliente :propCliente="itCLiente" @meDelete="deletarUsuario($event)" :showAge="true"/>
    </div>
  </div>
</template>

<script>
import Cliente from './components/Cliente';
//sudo npm i --save lodash
import _ from 'lodash';
//import Produto from './components/Produto';

export default {
  name: 'App',
  data(){
    return{
      deuRuim: false,
      nomeField: "",
      emailField: "",
      idadeField: 0,
      vtClientes: [
        {
          id: 2,
          nome: "Cristiano Vieira",
          email: "cristiano@vieira.com",
          idade: 64
        },
        {
          id: 4,
          nome: "Jonny De Bruce",
          email: "zoid@bruce.com",
          idade: 32          
        },
        {
          id: 6,
          nome: "Bruce Wayne",
          email: "bruce@wayne.com",
          idade: 16          
        }
      ]
    }
  },
  components: {
    Cliente,
    //Produto
  },
  methods: {
    cadastrarUsuario: function(){
      if(this.nomeField == ""){
        this.deuRuim = true;
      }else{
        this.vtClientes.push({
            id: Date.now(),
            nome: this.nomeField,
            email: this.emailField,
            idade: this.idadeField
        });
        this.nomeField = "";
        this.emailField = "";
        this.idadeField = 0;
        this.deuRuim = false;
      }      
    },
    deletarUsuario: function($event){
      console.log("Recebendo evento");
      console.log($event);
      $event.component.isPremium = true;
      $event.component.testaPassagemMetodos();

      //Forma de deletar registros
      var id = $event.idCliente;     
      console.log(id);
      var novoArray = this.vtClientes.filter(c => c.id != id);
      this.vtClientes = novoArray;

    }
  },
  computed: {
    orderClientes: function(){
      return _.orderBy(this.vtClientes, ['nome', 'idade'], ['asc', 'desc']);
    }
  }
}
</script>

<style>
  #nomeError{
    color: darkred;
  }
</style>
